"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HapiServiceProvider_1 = require("../HapiServiceProvider");
var ActionName_1 = require("./ActionName");
function action(path, method, name) {
    return function (target, key, descriptor) {
        name = ActionName_1.findOrAddActionName(target, name);
        var constructor = target.constructor;
        var route = {
            name: name,
            path: path,
            method: method,
            actionObject: constructor,
            actionMethod: key,
        };
        var routes = Reflect.getMetadata("protoculture-hapi:routes", constructor) || {};
        routes[name] = route;
        Reflect.defineMetadata("protoculture-hapi:routes", routes, constructor);
        HapiServiceProvider_1.HapiServiceProvider.routedTargets.push(constructor);
    };
}
exports.action = action;
//# sourceMappingURL=Action.js.map