"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Chance = require("chance");
function actionName(name) {
    return function (target) {
        findOrAddActionName(target, name);
    };
}
exports.actionName = actionName;
function findOrAddActionName(target, name) {
    var names = Reflect.getMetadata("protoculture-hapi:route-names", target) || [];
    if (name) {
        names.push(name);
    }
    if (!names.length) {
        names.push((new Chance()).guid());
    }
    Reflect.defineMetadata("protoculture-hapi:route-names", target, names);
    return name || names[0];
}
exports.findOrAddActionName = findOrAddActionName;
//# sourceMappingURL=ActionName.js.map