import * as Hapi from "hapi";
import { interfaces } from "inversify";
import { YarOptions } from "yar";
import { RouteType } from "./Route";
import { AuthStrategy } from "./AuthStrategy";
declare module "protoculture/lib/ServiceProvider" {
    interface ServiceProvider {
        configureConnection(connectionFactory: ConnectionFactory): void;
        configureRoutes(routes: RouteType[]): void;
        configureRoute(route: RouteType): void;
        configureSession(options: YarOptions): void;
        configureAuthStrategy(authStrategy: AuthStrategy): void;
    }
}
export declare type ConnectionFactory = (container: interfaces.Container) => Hapi.ServerConnectionOptions;
