"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var protoculture_1 = require("protoculture");
var index_1 = require("./index");
protoculture_1.ServiceProvider.prototype.configureConnection = function (connectionFactory) {
    var connection = connectionFactory(this.bundle.container);
    this.bundle.container.bind(index_1.hapiSymbols.ServerConnectionOptions)
        .toConstantValue(connection);
};
protoculture_1.ServiceProvider.prototype.configureRoutes = function (routes) {
    var _this = this;
    _.each(routes, function (route) { return _this.configureRoute(route); });
};
protoculture_1.ServiceProvider.prototype.configureRoute = function (route) {
    this.bundle.container.bind(index_1.hapiSymbols.Route)
        .toConstantValue(route);
};
protoculture_1.ServiceProvider.prototype.configureSession = function (options) {
    this.bundle.container.bind(index_1.hapiSymbols.SessionOptions)
        .toConstantValue(options);
};
protoculture_1.ServiceProvider.prototype.configureAuthStrategy = function (strategy) {
    this.bundle.container.bind(index_1.hapiSymbols.AuthStrategy)
        .toConstantValue(strategy);
};
//# sourceMappingURL=Extensions.js.map